/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package saboteur;

import java.util.*;

public class Deck {//All possible cards in the game
    
    //All possible side configurations
    boolean fourConnections[] = new boolean[]{true, true, true, true};//URDL
    boolean threeConnectionsUp[] = new boolean[]{true, true, false, true};//URL
    boolean threeConnectionsLeft[] = new boolean[]{true, false, true, true};//UDL
    boolean twoConnectionsUpLeft[] = new boolean[]{true, false, false, true};//UL 
    boolean twoConnectionsUpRight[] = new boolean[]{true, true, false, false};//UR
    boolean twoConnectionsUpDown[] = new boolean[]{true, false, true, false};//UD
    boolean twoConnectionsLeftRight[] = new boolean[]{false, true, false, true};//RL
    boolean oneConnectionUp[] = new boolean[]{true, false, false, false};//U    
    boolean oneConnectionLeft[] = new boolean[]{false, false, false, true};//L
    
    //All possible opening configurations
    boolean fourOpen[] = new boolean[]{true, true, true, true};//URDL 
    boolean threeOpenUp[] = new boolean[]{true, true, false, true};//ULR 
    boolean threeOpenLeft[] = new boolean[]{true, false, true, true};//UDL 
    boolean twoOpenUpLeft[] = new boolean[]{true, false, false, true};//UL
    boolean twoOpenDownLeft[] = new boolean[]{false, false, true, true};//Dl 
    boolean twoOpenLeftRight[] = new boolean[]{false, true, false, true};//LR
    boolean twoOpenUpDown[] = new boolean[]{true, false, true, false};//UD
    boolean oneOpenUp[] = new boolean[]{true, false, false, false};//U
    boolean oneOpenLeft[] = new boolean[]{false, false, false, true};//L 
    boolean fourClosed[] = new boolean[]{false, false, false, false};//
    
    boolean threeConnectionsDown[] = new boolean[]{false, true, true, true};//RDL
    boolean threeConnectionsRight[] = new boolean[]{true, true, true, false};//URD
    boolean twoConnectionsDownRight[] = new boolean[]{false, true, true, false};//RD 
    boolean twoConnectionsDownLeft[] = new boolean[]{false, false, true, true};//DL
    boolean oneConnectionDown[] = new boolean[]{false, false, true, false};//D   
    boolean oneConnectionRight[] = new boolean[]{false, true, false, false};//R
    
    //All possible opening configurations
    boolean threeOpenDown[] = new boolean[]{false, true, true, true};//LDR 
    boolean threeOpenRight[] = new boolean[]{true, true, true, false};//URD 
    boolean twoOpenDownRight[] = new boolean[]{false, true, true, false};//DR
    boolean twoOpenUpRight[] = new boolean[]{true, true, false, false};//UR 
    boolean oneOpenDown[] = new boolean[]{false, false, true, false};//U
    boolean oneOpenRight[] = new boolean[]{false, true, false, false};//R 
   
//Dead end cards:
        
    //4 Dead ends
    PathCard fourDeadEnds = new PathCard(fourConnections, fourClosed);
    
    //3 Dead ends left
    PathCard ThreeDeadEndsLeft = new PathCard(threeConnectionsLeft, fourClosed);   
    
    //3 Dead end up
    PathCard ThreeDeadEndsUp = new PathCard(threeConnectionsUp, fourClosed);
        
    //2 Dead ends left up
    PathCard twoDeadEndsUpLeft = new PathCard(twoConnectionsUpLeft, fourClosed);
    
    //2 Dead ends up right
    PathCard twoDeadEndsUpRight = new PathCard(twoConnectionsUpRight, fourClosed); 
    
    //2 Dead ends left right
    PathCard twoDeadEndsLeftRight = new PathCard(twoConnectionsLeftRight, fourClosed); 
    
    //2 Dead ends up down
    PathCard twoDeadEndsUpDown = new PathCard(twoConnectionsUpDown, fourClosed);
    
    //1 Dead end left
    PathCard oneDeadEndLeft = new PathCard(oneConnectionLeft, fourClosed);
    
    //1 Dead end up
    PathCard oneDeadEndUp = new PathCard(oneConnectionUp, fourClosed);
   
//Open end cards:    
    
    //4 Open ends
    PathCard fourOpenEnds = new PathCard(fourConnections, fourOpen);
    
    //3 Open ends left
    PathCard ThreeOpenEndsLeft = new PathCard(threeConnectionsLeft, threeOpenLeft);   
    
    //3 Open end up
    PathCard ThreeOpenEndsUp = new PathCard(threeConnectionsUp, threeOpenUp);
        
    //2 Open ends left up
    PathCard twoOpenEndsUpLeft = new PathCard(twoConnectionsUpLeft, twoOpenUpLeft);
    
    //2 Open ends left down
    PathCard twoOpenEndsDownLeft = new PathCard(twoConnectionsUpRight, twoOpenDownLeft); 
    
    //2 Open ends left right
    PathCard twoOpenEndsLeftRight = new PathCard(twoConnectionsLeftRight, twoOpenLeftRight); 
    
    //2 Open ends up down
    PathCard twoOpenEndsUpDown = new PathCard(twoConnectionsUpDown, twoOpenUpDown);
    
    
       
    //block card
    BlockCard blockCard = new BlockCard();
    
    //deblock card
    DeblockCard deblockCard = new DeblockCard();  
    
    //demolish card
    DemolishCard demolishCard = new DemolishCard();
    
    //view card
    ViewCard viewCard = new ViewCard();
   
    public Vector<Card> getCards(){
        Vector<Card> handCards = new Vector<Card>();
        handCards.add(fourDeadEnds);
        handCards.add(ThreeDeadEndsLeft);
        handCards.add(ThreeDeadEndsUp);
        handCards.add(twoDeadEndsUpLeft);
        handCards.add(twoDeadEndsUpRight);
        handCards.add(twoDeadEndsLeftRight);
        handCards.add(twoDeadEndsUpDown);
        handCards.add(oneDeadEndLeft);
        handCards.add(oneDeadEndUp);
        
        for (int i=0; i<5; i++) {
            handCards.add((PathCard) fourOpenEnds.clone());
        }
        for (int i=0; i<5; i++) {        
            handCards.add((PathCard) ThreeOpenEndsLeft.clone());
        }
        for (int i=0; i<5; i++) {
            handCards.add((PathCard) ThreeOpenEndsUp.clone());
        }
        for (int i=0; i<4; i++) {
            handCards.add((PathCard) twoOpenEndsUpLeft.clone());
        }
        for (int i=0; i<5; i++) {
            handCards.add((PathCard) twoOpenEndsDownLeft.clone());
        }
        for (int i=0; i<4; i++) {        
            handCards.add((PathCard) twoOpenEndsLeftRight.clone());
        }
        for (int i=0; i<3; i++) {
            handCards.add((PathCard) twoOpenEndsUpDown.clone());
        }     
        for (int i=0; i<9; i++) {
            handCards.add((DeblockCard) deblockCard.clone());
        }
        for (int i=0; i<9; i++) {
            handCards.add((BlockCard) blockCard.clone());
        }
        for (int i=0; i<3; i++) {
            handCards.add((DemolishCard) demolishCard.clone());           
        }
        for (int i=0; i<6; i++) {
            handCards.add((ViewCard) viewCard.clone());           
        }
        Collections.shuffle(handCards);
        return handCards;
    }
}
