/*
 * This class defines the cards with a path on it
 */
package saboteur;

/*
 * Authors: Dyon Veldhuis, Eric Jansen, Eveline Broers
 */

import java.util.*;

public class PathCard extends Card {
    private boolean[] sides;
    private boolean[] opened;
    
    // At which sides are paths? (stored in 'sides')
    // Is the path open (does it lead anywhere?) or is it a dead end
    public PathCard(boolean sides[], boolean opened[]){
        this.sides = sides;
        this.opened = opened;
    }
    
    // Return at which sides of the cards there are paths
    public boolean[] getSides(){
        return sides;
    }
    
    // Return whether the paths are a dead end or not (true: open; false: dead end)
    public boolean[] getOpened(){
        return opened;
    }
    
}
