/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package saboteur;

/**
 *
 * @author a1712543
 */
import java.util.*;
import javax.swing.JLabel;

public class Saboteur {

    public PathCard[][] getBoard() {
       return board; 
    }
    
    //public int amountOfGold[] = new int[5]; // KAN WEG??
    public Vector<Card> stock;
    public Agent[] agents = new Agent[5];
    public int win = 0;//0:No Winner, 1:Miners win, 2:Saboteurs Win
    public PathCard[][] board = new PathCard[13][13];//Create board with a width of 13 amd a heigth of 13
    public boolean[][] shadowBoard = new boolean[13][13];//Create shadowboard to see where the recursion already has been
    int goldCardPosition;
    Display display = new Display();
    boolean[] saboteurRole = new boolean[5];
        
   Saboteur() throws InterruptedException{
       
    initialize(); 
    //tutorial = new Tutorial();
    
   }

  public void initialize() throws InterruptedException {
    
    for(int round = 0; round < 3; round++) { // TODO: bij elke ronde met een leeg speelbord beginnen
        display.initializeGoalCards();
        display.round = round;
        display.initializeBoard();
        display.addText("Round " + (round+1));
        display.addText("\n");
        display.addText("\n");
        
        int turns = 0;
        win = 0;//0:No Winner, 1:Miners win, 2:Saboteurs Win
        //board = new PathCard[13][13];//Create a new board with a width of 13 amd a heigth of 13
        boolean saboteur = true;
        boolean miner = false;
        Deck deck = new Deck();
        stock = deck.getCards();

        //Set every position of the shadow board at false
        for(int i = 0; i < 13; i++) {
            for(int j = 0; j < 13; j++) {
                shadowBoard[i][j] = false;
                board[i][j] = null;
            }
        }

        //define the properties of a the start and goal cards
        boolean fourConnections[] = new boolean[]{true, true, true, true};
        boolean fourOpen[] = new boolean[]{true, true, true, true}; 

        //place the start card on the board
        board[6][2] = new StartCard(fourConnections, fourOpen);

        //place the goal cards on the board
        //GoalCard goalCard = new GoalCard(fourConnections, fourOpen, true);
        Random rand = new Random();
        int goldPosition = rand.nextInt(3);

        if (goldPosition == 0) {
            board[4][10] = new GoalCard(fourConnections, fourOpen, true);
            board[6][10] = new GoalCard(fourConnections, fourOpen, false);
            board[8][10] = new GoalCard(fourConnections, fourOpen, false);
            goldCardPosition = 4;
        }
        if (goldPosition == 1) {
            board[4][10] = new GoalCard(fourConnections, fourOpen, false);
            board[6][10] = new GoalCard(fourConnections, fourOpen, true);
            board[8][10] = new GoalCard(fourConnections, fourOpen, false);
            goldCardPosition = 6;
        }
        if (goldPosition == 2) {
            board[4][10] = new GoalCard(fourConnections, fourOpen, false);
            board[6][10] = new GoalCard(fourConnections, fourOpen, false);
            board[8][10] = new GoalCard(fourConnections, fourOpen, true);
            goldCardPosition = 8;
        }
        //System.out.println(goldCardPosition);
        //create the agents and their roles
        Random role = new Random();

        int saboteur1 = role.nextInt(5);
        int saboteur2 = role.nextInt(5);
        while (saboteur1 == saboteur2) {
            saboteur2 = role.nextInt(5);
        }
        
        for(int j = 0; j < 5; j++){
            if(round == 0) {
                agents[j] = new Agent(miner, j, round);
            } 
            
            if(j == saboteur1 || j == saboteur2){
                agents[j].setRole(saboteur);
                saboteurRole[j] = true;
            } else {
                saboteurRole[j] = false;
                agents[j].setRole(miner);
            }
            agents[j].resetKripke();
            agents[j].handCards.clear();
            agents[j].resetGoal();
            agents[j].setBlocked(false);
        }
        display.drawSaboteurs(saboteurRole);
        
        for(int j = 0; j < 5; j++) {
            display.showGold(j, agents[j].getGold());      
        }
        
        //Deal the first handcards
        for(int k = 0; k < 5; k++){
            for (int j = 0; j < 6; j++) {
                agents[k].handCards.add(stock.get(0));
                stock.remove(0);
            }
        }    
        display.draww(board);
        for(int j = 0; j < 5; j++){             
            for(int i = 0; i < agents[j].handCards.size(); i++){
                if(agents[j].handCards.get(i) instanceof BlockCard) {
                    display.handCardLabelBoard[j][i].setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/red.PNG")));
                }
                else if(agents[j].handCards.get(i) instanceof BlockCard) { 
                    display.handCardLabelBoard[j][i].setIcon(new javax.swing.ImageIcon(getClass().getResource("/saboteur/image/green.PNG")));                                      
                } else {
                    display.drawCard(agents[j].handCards.get(i), display.handCardLabelBoard[j][i]);
                }
            }
        }
                        
        //Turns
        while(win==0){//No winner 
            if(display.next || display.show) {
                int j = turns%5;
                
                Turn turn = agents[j].takeTurn(agents, board);
                Card playCard = null;
                if(turn == null) {
                    display.drawCard(agents[j].discardCard, display.playDiscardBoard[1]);
                    //System.out.println("discard");
                }
                if(turn != null){//Card Played
                    playCard = turn.getCard();
                    //System.out.println("play");
                    int[] target = turn.getTarget();
                    if(playCard != null){
                        for(int i = 0; i < 5; i++) {
                            agents[i].updateKripke(turn, j, board, agents); // update the kripke model for agent i about agent j
                        }
                    } 
                    if(playCard instanceof PathCard){
                        placePathTile((PathCard)playCard,target[0],target[1]);              
                        display.drawCard(playCard,display.labelBoard[target[0]][target[1]]);
                        //display.drawCard(playCard,display.playDiscardBoard[0]);
                    } else if(playCard instanceof BlockCard){
                        block(agents[target[0]]);
                        display.setAgent(target[0]);                      
                        //display.drawCard(playCard, display.playDiscardBoard[0]);
                    } else if(playCard instanceof DeblockCard){
                        deblock(agents[target[0]]);
                        display.setAgent(target[0]);
                        //display.drawCard(playCard, display.playDiscardBoard[0]);
                        //System.out.println(j +" deblock");
                    } else if(playCard instanceof DemolishCard){
                        demolish(target[0],target[1]);                        
                        display.labelBoard[target[0]][target[1]].setIcon(null);
                        //display.drawCard(playCard, display.playDiscardBoard[0]);
                    } else {
                        int knowGold = agents[j].setGoal((target[0]/2)-2,view(target[0],target[1], j));
                        if(knowGold < 5){
                            display.setGoalCards(knowGold, true, j);
                        }
                    }
                    display.drawCard(playCard,display.playDiscardBoard[0]);
                }

                if(!stock.isEmpty()){
                    agents[j].handCards.add(stock.get(0));
                    stock.remove(0);//Remove the picked card
                }



                evaluateWin(goldCardPosition, 10);  
                for(int o = 0; o < 13; o++) {
                    for(int p = 0; p < 13; p++) {
                        shadowBoard[o][p] = false;
                    }
                }
                display.setLabel(j);
                turns++;


                display.turn = turns;
                if(display.next){
                    display.next = false;               
                    for(int i = 0; i < 6; i++){
                        if(i < agents[j].handCards.size()){
                            display.drawCard(agents[j].handCards.get(i), display.handCardLabelBoard[j][i]);
                        } else {
                            display.handCardLabelBoard[j][i].setIcon(null);
                        }
                    }                 
                }
            }    
        }
                
        display.show = false;
        
        //display.draww(board);

        

        if(win == 2){
            for(int i = 0; i < 5; i++){
                if(agents[i].getRole()){
                    agents[i].addGold();
                }
            }
        } else {
            for(int i = 0; i < 5; i++){
                if(agents[i].getRole() == false){
                    agents[i].addGold();
                }
            }
        }
        int[] saboteurs = new int[2];
        for(int i=0; i<5; i++){
            display.addText("agent " + i + " believes in states: ");
            for(int j=0; j<10; j++){
                for(int k = 0; k < 10; k++){
                    if(agents[i].getKripke().getRelations()[i][k][j] > agents[i].getKripke().treshold) {
                        saboteurs = agents[i].getKripke().getStates()[j].getSaboteurs();
                        display.addText("(" + saboteurs[0] + "," + saboteurs[1] + ") ");
                        k = 10;
                    }
                }
            }
            display.addText("\n");
            for(int p = 0; p < 5; p++){
                if(p != i){
                    display.addText("agent " + i + " believes that agent " + p + " believes in states: ");
                    for(int j=0; j<10; j++){
                        for(int k = 0; k < 10; k++){
                            if(agents[i].getKripke().getRelations()[p][k][j] > agents[i].getKripke().treshold) {
                                saboteurs = agents[i].getKripke().getStates()[j].getSaboteurs();
                                display.addText("(" + saboteurs[0] + "," + saboteurs[1] + ") ");
                                k = 10;
                            }
                        }
                    }
                    display.addText("\n");
                }
            }
            display.addText("\n");
        }
        if(saboteur1 < saboteur2){
            display.addText("Actual state: (" + saboteur1 + "," + saboteur2 + ")");
            display.addText("\n");
        } else {
            display.addText("Actual state: (" + saboteur2 + "," + saboteur1 + ")");
            display.addText("\n");
        }
        display.addText("\n");
        if(win == 1){
            display.addText("win: miners");
            display.addText("\n");
        } else {
            display.addText("win: saboteurs");
            display.addText("\n");
        }
        display.addText("\n");
        
        
        /*for(int i = 0; i < 5; i++) {
            System.out.println("round: " + round + "   agent: " + i + "   saboteur: " + agents[i].getRole() + "   gold: " + agents[i].getGold());
        }*/
        display.addText("\n");
        
        // who won?
        while(!(display.next || display.show)){
            
        }
        display.next = false;
        display.show = false;
        
        
    }
    for(int j = 0; j < 5; j++) {
        display.showGold(j, agents[j].getGold());      
    }
    
    display.addText("Winner(s):");
    display.addText("\n");
    //int[] highest = new int[5];
    int highest = 0;
    //agents[0].getGold();
    for(int i = 1; i < 5; i++) {
        if(agents[i].getGold() >= agents[highest].getGold()) {
            highest = i;
        }
    }
    for(int i = 0; i < 5; i++) {
        if(agents[i].getGold() == agents[highest].getGold()) {
            display.addText("Agent " + i);
            display.addText("\n");
        }
    }
            
  }
  
  public void placePathTile(PathCard pathCard, int x, int y) {
      board[x][y] = pathCard;
  }
  
  public void block(Agent blockAgent) {
      blockAgent.setBlocked(true);
  }
      
  public void deblock(Agent blockedAgent) {
      blockedAgent.setBlocked(false);
  }
  
  public void demolish(int x, int y) {
      board[x][y] = null;
  }
  
  public boolean view(int x, int y, int agent) {
      GoalCard goal;
      boolean gold = false;
      goal = (GoalCard)board[x][y]; 
      gold = goal.getGold();
      display.setGoalCards((x/2)-2, gold, agent);
      return gold;
  }
  
  public void evaluateWin(int xCoordinate, int yCoordinate) {//check whether one of the team won   
      boolean[] opened = board[xCoordinate][yCoordinate].getOpened();
      boolean[] sides = board[xCoordinate][yCoordinate].getSides();
      boolean empty = true;
      shadowBoard[xCoordinate][yCoordinate] = true;//remember that recursion already evaluated this tile
      if(xCoordinate == 6 && yCoordinate == 2) {
            win = 1;
      } else {           
            if(yCoordinate < 12 && opened[0] && sides[0] && board[xCoordinate][yCoordinate+1]!=null && shadowBoard[xCoordinate][yCoordinate+1]==false) {//check if there is a card there              
                evaluateWin(xCoordinate, yCoordinate+1);//Card at North
            } 
            if(yCoordinate > 0 && opened[2] && sides[2] && board[xCoordinate][yCoordinate-1]!=null && shadowBoard[xCoordinate][yCoordinate-1]==false) {//check if there is a card there           
                evaluateWin(xCoordinate, yCoordinate-1);//Card at South
            }      
            if(xCoordinate < 12 && opened[3] && sides[3] && board[xCoordinate+1][yCoordinate]!=null && shadowBoard[xCoordinate+1][yCoordinate]==false) {//check if there is a card there
                evaluateWin(xCoordinate+1, yCoordinate);//Card at Right
            }  
            if(xCoordinate > 0 && opened[1] && sides[1] && board[xCoordinate-1][yCoordinate]!=null && shadowBoard[xCoordinate-1][yCoordinate]==false) {//check if there is a card there
                evaluateWin(xCoordinate-1, yCoordinate);//Card at Left
            }  
        } 
        if(win == 0) {
            for(int j = 0; j < 5; j++){
                if(agents[j].handCards.isEmpty() == false) {
                    empty = false;
                }
            }
            if (empty == true) {
                win = 2;
            }    
        }
      
    } 
 
    
  public static void main(String[] args) throws InterruptedException {
    new Saboteur();
  }  
}
